linux/tools/perf/tests/shell/trace_btf_general.sh
Thomas Richter 4cf1f549bb perf test: Make perf trace BTF general tests exclusive
Running both tests cases 126 128 together causes the first test case
126 to fail:
 # for i in $(seq 3); do ./perf test 'perf trace BTF general tests' \
	'perf trace record and replay'; done
 126: perf trace BTF general tests    : FAILED!
 128: perf trace record and replay    : Ok
 126: perf trace BTF general tests    : FAILED!
 128: perf trace record and replay    : Ok
 126: perf trace BTF general tests    : FAILED!
 128: perf trace record and replay    : Ok
 #

Test case 126 fails because test case 128 runs concurrently as can
be observed using a ps -ef | grep perf output list on a different
window. Both do a perf trace command concurrently.
Make test case 'perf trace BTF general tests' exclusive.

Output after:
 # for i in $(seq 3); do ./perf test 'perf trace BTF general tests' \
	'perf trace record and replay'; done
 127: perf trace BTF general tests                   : Ok
 155: perf trace record and replay                   : Ok
 127: perf trace BTF general tests                   : Ok
 155: perf trace record and replay                   : Ok
 127: perf trace BTF general tests                   : Ok
 155: perf trace record and replay                   : Ok
 #

Signed-off-by: Thomas Richter <tmricht@linux.ibm.com>
Acked-by: Howard Chu <howardchu95@gmail.com>
Signed-off-by: Namhyung Kim <namhyung@kernel.org>
2026-04-08 21:42:25 -07:00

95 lines
2.2 KiB
Bash
Executable File

#!/bin/bash
# perf trace BTF general tests (exclusive)
# SPDX-License-Identifier: GPL-2.0
err=0
# shellcheck source=lib/probe.sh
. "$(dirname $0)"/lib/probe.sh
file1=$(mktemp /tmp/file1_XXXX)
file2=$(echo $file1 | sed 's/file1/file2/g')
buffer="buffer content"
perf_config_tmp=$(mktemp /tmp/.perfconfig_XXXXX)
trap cleanup EXIT TERM INT HUP
check_vmlinux() {
echo "Checking if vmlinux BTF exists"
if [ ! -f /sys/kernel/btf/vmlinux ]
then
echo "Skipped due to missing vmlinux BTF"
return 2
fi
return 0
}
trace_test_string() {
echo "Testing perf trace's string augmentation"
output="$(perf trace --sort-events -e renameat* --max-events=1 -- mv ${file1} ${file2} 2>&1)"
if ! echo "$output" | grep -q -E "^mv/[0-9]+ renameat(2)?\(.*, \"${file1}\", .*, \"${file2}\", .*\) += +[0-9]+$"
then
printf "String augmentation test failed, output:\n$output\n"
err=1
fi
}
trace_test_buffer() {
echo "Testing perf trace's buffer augmentation"
# echo will insert a newline (\10) at the end of the buffer
output="$(perf trace --sort-events -e write --max-events=1 -- echo "${buffer}" 2>&1)"
if ! echo "$output" | grep -q -E "^echo/[0-9]+ write\([0-9]+, ${buffer}.*, [0-9]+\) += +[0-9]+$"
then
printf "Buffer augmentation test failed, output:\n$output\n"
err=1
fi
}
trace_test_struct_btf() {
echo "Testing perf trace's struct augmentation"
output="$(perf trace --sort-events -e clock_nanosleep --force-btf --max-events=1 -- sleep 1 2>&1)"
if ! echo "$output" | grep -q -E "^sleep/[0-9]+ clock_nanosleep\(0, 0, \{1,.*\}, 0x[0-9a-f]+\) += +[0-9]+$"
then
printf "BTF struct augmentation test failed, output:\n$output\n"
err=1
fi
}
cleanup() {
rm -rf ${file1} ${file2} ${perf_config_tmp}
}
trap_cleanup() {
echo "Unexpected signal in ${FUNCNAME[1]}"
cleanup
exit 1
}
# don't overwrite user's perf config
trace_config() {
export PERF_CONFIG=${perf_config_tmp}
perf config trace.show_arg_names=false trace.show_duration=false \
trace.show_timestamp=false trace.args_alignment=0
}
skip_if_no_perf_trace || exit 2
check_vmlinux || exit 2
[ "$(id -u)" = 0 ] || exit 2
trace_config
trace_test_string
if [ $err = 0 ]; then
trace_test_buffer
fi
if [ $err = 0 ]; then
trace_test_struct_btf
fi
cleanup
exit $err